diff --git a/doc/builtins.0 b/doc/builtins.0
index dcdc6c51..e92e583c 100644
--- a/doc/builtins.0
+++ b/doc/builtins.0
@@ -46,7 +46,7 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
               AAlliiaass with no arguments or with the --pp option prints the list of
               aliases in the form aalliiaass _n_a_m_e=_v_a_l_u_e on standard  output.   When
               arguments  are supplied, an alias is defined for each _n_a_m_e whose
-              _v_a_l_u_e is given.  A trailing space in  _v_a_l_u_e causes the next word
+              _v_a_l_u_e is given.  A trailing space in _v_a_l_u_e causes the next  word
               to be checked for alias substitution when the alias is expanded.
               For each _n_a_m_e in the argument list for which no  _v_a_l_u_e  is  sup-
               plied,  the  name  and  value  of  the  alias is printed.  AAlliiaass
@@ -66,7 +66,7 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
        bbiinndd [--mm _k_e_y_m_a_p] --ff _f_i_l_e_n_a_m_e
        bbiinndd [--mm _k_e_y_m_a_p] --xx _k_e_y_s_e_q:_s_h_e_l_l_-_c_o_m_m_a_n_d
        bbiinndd [--mm _k_e_y_m_a_p] _k_e_y_s_e_q:_f_u_n_c_t_i_o_n_-_n_a_m_e
-       bbiinndd _r_e_a_d_l_i_n_e_-_c_o_m_m_a_n_d
+       bbiinndd [--mm _k_e_y_m_a_p] _k_e_y_s_e_q:_r_e_a_d_l_i_n_e_-_c_o_m_m_a_n_d
               Display current rreeaaddlliinnee key and function bindings, bind  a  key
               sequence  to  a  rreeaaddlliinnee  function  or macro, or set a rreeaaddlliinnee
               variable.  Each non-option argument is a  command  as  it  would
@@ -152,7 +152,7 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
               directory names in CCDDPPAATTHH are separated by a colon (:).  A  null
               directory  name  in CCDDPPAATTHH is the same as the current directory,
               i.e., ``..''.  If _d_i_r begins with a slash (/), then CCDDPPAATTHH is not
-              used.  The  --PP  option  causes  ccdd to use the physical directory
+              used.   The  --PP  option  causes ccdd to use the physical directory
               structure by resolving symbolic links while traversing  _d_i_r  and
               before processing instances of _._. in _d_i_r (see also the --PP option
               to the sseett builtin command); the --LL option forces symbolic links
@@ -174,7 +174,7 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
 
        ccoommmmaanndd [--ppVVvv] _c_o_m_m_a_n_d [_a_r_g ...]
               Run  _c_o_m_m_a_n_d  with  _a_r_g_s  suppressing  the normal shell function
-              lookup. Only builtin commands or commands found in the PPAATTHH  are
+              lookup.  Only builtin commands or commands found in the PPAATTHH are
               executed.   If the --pp option is given, the search for _c_o_m_m_a_n_d is
               performed using a default value for PPAATTHH that is  guaranteed  to
               find  all  of  the  standard  utilities.  If either the --VV or --vv
@@ -401,11 +401,11 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
                      attribute is disabled.
               --nn     Give  each  _n_a_m_e  the _n_a_m_e_r_e_f attribute, making it a name
                      reference to another variable.  That  other  variable  is
-                     defined by the value of _n_a_m_e.  All references and assign-
-                     ments to _n_a_m_e,  except  for  changing  the  --nn  attribute
-                     itself,  are  performed  on  the  variable  referenced by
-                     _n_a_m_e's value.  The --nn  attribute  cannot  be  applied  to
-                     array variables.
+                     defined  by  the  value of _n_a_m_e.  All references, assign-
+                     ments, and attribute modifications to  _n_a_m_e,  except  for
+                     changing  the  --nn  attribute itself, are performed on the
+                     variable  referenced  by  _n_a_m_e's  value.    The   nameref
+                     attribute cannot be applied to array variables.
               --rr     Make _n_a_m_es readonly.  These names cannot then be assigned
                      values by subsequent assignment statements or unset.
               --tt     Give each _n_a_m_e the  _t_r_a_c_e  attribute.   Traced  functions
@@ -787,151 +787,153 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
 
        llooggoouutt Exit a login shell.
 
-       mmaappffiillee  [--nn  _c_o_u_n_t]  [--OO _o_r_i_g_i_n] [--ss _c_o_u_n_t] [--tt] [--uu _f_d] [--CC _c_a_l_l_b_a_c_k]
-       [--cc _q_u_a_n_t_u_m] [_a_r_r_a_y]
-       rreeaaddaarrrraayy  [--nn _c_o_u_n_t] [--OO _o_r_i_g_i_n] [--ss _c_o_u_n_t] [--tt] [--uu _f_d] [--CC _c_a_l_l_b_a_c_k]
-       [--cc _q_u_a_n_t_u_m] [_a_r_r_a_y]
+       mmaappffiillee  [--dd  _d_e_l_i_m] [--nn _c_o_u_n_t] [--OO _o_r_i_g_i_n] [--ss _c_o_u_n_t] [--tt] [--uu _f_d] [--CC
+       _c_a_l_l_b_a_c_k] [--cc _q_u_a_n_t_u_m] [_a_r_r_a_y]
+       rreeaaddaarrrraayy [--dd _d_e_l_i_m] [--nn _c_o_u_n_t] [--OO _o_r_i_g_i_n] [--ss _c_o_u_n_t] [--tt] [--uu _f_d] [--CC
+       _c_a_l_l_b_a_c_k] [--cc _q_u_a_n_t_u_m] [_a_r_r_a_y]
               Read  lines from the standard input into the indexed array vari-
               able _a_r_r_a_y, or from file descriptor _f_d if the --uu option is  sup-
               plied.   The variable MMAAPPFFIILLEE is the default _a_r_r_a_y.  Options, if
               supplied, have the following meanings:
-              --nn     Copy at most _c_o_u_n_t lines.  If _c_o_u_n_t is 0, all  lines  are
+              --dd     The first character of _d_e_l_i_m is used  to  terminate  each
+                     input line, rather than newline.
+              --nn     Copy  at  most _c_o_u_n_t lines.  If _c_o_u_n_t is 0, all lines are
                      copied.
-              --OO     Begin  assigning  to  _a_r_r_a_y at index _o_r_i_g_i_n.  The default
+              --OO     Begin assigning to _a_r_r_a_y at index  _o_r_i_g_i_n.   The  default
                      index is 0.
               --ss     Discard the first _c_o_u_n_t lines read.
               --tt     Remove a trailing newline from each line read.
-              --uu     Read lines from file descriptor _f_d instead of  the  stan-
+              --uu     Read  lines  from file descriptor _f_d instead of the stan-
                      dard input.
-              --CC     Evaluate  _c_a_l_l_b_a_c_k each time _q_u_a_n_t_u_m lines are read.  The
+              --CC     Evaluate _c_a_l_l_b_a_c_k each time _q_u_a_n_t_u_m lines are read.   The
                      --cc option specifies _q_u_a_n_t_u_m.
-              --cc     Specify the number of lines read  between  each  call  to
+              --cc     Specify  the  number  of  lines read between each call to
                      _c_a_l_l_b_a_c_k.
 
-              If  --CC  is  specified  without  --cc, the default quantum is 5000.
+              If --CC is specified without --cc,  the  default  quantum  is  5000.
               When _c_a_l_l_b_a_c_k is evaluated, it is supplied the index of the next
               array element to be assigned and the line to be assigned to that
-              element as additional arguments.  _c_a_l_l_b_a_c_k  is  evaluated  after
+              element  as  additional  arguments.  _c_a_l_l_b_a_c_k is evaluated after
               the line is read but before the array element is assigned.
 
-              If  not  supplied  with  an  explicit origin, mmaappffiillee will clear
+              If not supplied with an  explicit  origin,  mmaappffiillee  will  clear
               _a_r_r_a_y before assigning to it.
 
-              mmaappffiillee returns successfully unless an invalid option or  option
-              argument  is  supplied,  _a_r_r_a_y is invalid or unassignable, or if
+              mmaappffiillee  returns successfully unless an invalid option or option
+              argument is supplied, _a_r_r_a_y is invalid or  unassignable,  or  if
               _a_r_r_a_y is not an indexed array.
 
        ppooppdd [-nn] [+_n] [-_n]
-              Removes entries from the directory stack.   With  no  arguments,
-              removes  the  top directory from the stack, and performs a ccdd to
+              Removes  entries  from  the directory stack.  With no arguments,
+              removes the top directory from the stack, and performs a  ccdd  to
               the new top directory.  Arguments, if supplied, have the follow-
               ing meanings:
-              --nn     Suppresses  the  normal change of directory when removing
-                     directories from the stack, so that  only  the  stack  is
+              --nn     Suppresses the normal change of directory  when  removing
+                     directories  from  the  stack,  so that only the stack is
                      manipulated.
-              ++_n     Removes  the _nth entry counting from the left of the list
-                     shown by ddiirrss, starting with zero.  For  example:  ``popd
+              ++_n     Removes the _nth entry counting from the left of the  list
+                     shown  by  ddiirrss, starting with zero.  For example: ``popd
                      +0'' removes the first directory, ``popd +1'' the second.
               --_n     Removes the _nth entry counting from the right of the list
-                     shown  by  ddiirrss, starting with zero.  For example: ``popd
-                     -0'' removes the last directory, ``popd -1'' the next  to
+                     shown by ddiirrss, starting with zero.  For  example:  ``popd
+                     -0''  removes the last directory, ``popd -1'' the next to
                      last.
 
-              If  the ppooppdd command is successful, a ddiirrss is performed as well,
-              and the return status is 0.  ppooppdd returns false  if  an  invalid
+              If the ppooppdd command is successful, a ddiirrss is performed as  well,
+              and  the  return  status is 0.  ppooppdd returns false if an invalid
               option is encountered, the directory stack is empty, a non-exis-
               tent directory stack entry is specified, or the directory change
               fails.
 
        pprriinnttff [--vv _v_a_r] _f_o_r_m_a_t [_a_r_g_u_m_e_n_t_s]
-              Write  the  formatted _a_r_g_u_m_e_n_t_s to the standard output under the
-              control of the _f_o_r_m_a_t.  The --vv option causes the  output  to  be
-              assigned  to  the  variable _v_a_r rather than being printed to the
+              Write the formatted _a_r_g_u_m_e_n_t_s to the standard output  under  the
+              control  of  the  _f_o_r_m_a_t.  The --vv option causes the output to be
+              assigned to the variable _v_a_r rather than being  printed  to  the
               standard output.
 
-              The _f_o_r_m_a_t is a character string which contains three  types  of
-              objects:  plain  characters, which are simply copied to standard
-              output, character escape  sequences,  which  are  converted  and
-              copied  to  the standard output, and format specifications, each
-              of which causes printing of the next  successive  _a_r_g_u_m_e_n_t.   In
+              The  _f_o_r_m_a_t  is a character string which contains three types of
+              objects: plain characters, which are simply copied  to  standard
+              output,  character  escape  sequences,  which  are converted and
+              copied to the standard output, and format  specifications,  each
+              of  which  causes  printing of the next successive _a_r_g_u_m_e_n_t.  In
               addition to the standard _p_r_i_n_t_f(1) format specifications, pprriinnttff
               interprets the following extensions:
               %%bb     causes pprriinnttff to expand backslash escape sequences in the
                      corresponding _a_r_g_u_m_e_n_t (except that \\cc terminates output,
-                     backslashes in \\'', \\"", and \\?? are not removed, and  octal
+                     backslashes  in \\'', \\"", and \\?? are not removed, and octal
                      escapes beginning with \\00 may contain up to four digits).
-              %%qq     causes pprriinnttff to output the corresponding _a_r_g_u_m_e_n_t  in  a
+              %%qq     causes  pprriinnttff  to output the corresponding _a_r_g_u_m_e_n_t in a
                      format that can be reused as shell input.
               %%((_d_a_t_e_f_m_t))TT
-                     causes  pprriinnttff  to  output the date-time string resulting
-                     from using _d_a_t_e_f_m_t as a format  string  for  _s_t_r_f_t_i_m_e(3).
+                     causes pprriinnttff to output the  date-time  string  resulting
+                     from  using  _d_a_t_e_f_m_t  as a format string for _s_t_r_f_t_i_m_e(3).
                      The corresponding _a_r_g_u_m_e_n_t is an integer representing the
-                     number of seconds since the epoch.  Two special  argument
-                     values  may  be used: -1 represents the current time, and
-                     -2 represents the time the  shell  was  invoked.   If  no
-                     argument  is  specified,  conversion behaves as if -1 had
-                     been given.  This is an exception  to  the  usual  pprriinnttff
+                     number  of seconds since the epoch.  Two special argument
+                     values may be used: -1 represents the current  time,  and
+                     -2  represents  the  time  the  shell was invoked.  If no
+                     argument is specified, conversion behaves as  if  -1  had
+                     been  given.   This  is  an exception to the usual pprriinnttff
                      behavior.
 
-              Arguments  to non-string format specifiers are treated as C con-
+              Arguments to non-string format specifiers are treated as C  con-
               stants, except that a leading plus or minus sign is allowed, and
-              if  the leading character is a single or double quote, the value
+              if the leading character is a single or double quote, the  value
               is the ASCII value of the following character.
 
-              The _f_o_r_m_a_t is reused as necessary to consume all  of  the  _a_r_g_u_-
+              The  _f_o_r_m_a_t  is  reused as necessary to consume all of the _a_r_g_u_-
               _m_e_n_t_s.  If the _f_o_r_m_a_t requires more _a_r_g_u_m_e_n_t_s than are supplied,
-              the extra format specifications behave as if  a  zero  value  or
-              null  string,  as  appropriate,  had  been supplied.  The return
+              the  extra  format  specifications  behave as if a zero value or
+              null string, as appropriate,  had  been  supplied.   The  return
               value is zero on success, non-zero on failure.
 
        ppuusshhdd [--nn] [+_n] [-_n]
        ppuusshhdd [--nn] [_d_i_r]
-              Adds a directory to the top of the directory stack,  or  rotates
-              the  stack,  making the new top of the stack the current working
+              Adds  a  directory to the top of the directory stack, or rotates
+              the stack, making the new top of the stack the  current  working
               directory.  With no arguments, exchanges the top two directories
-              and  returns 0, unless the directory stack is empty.  Arguments,
+              and returns 0, unless the directory stack is empty.   Arguments,
               if supplied, have the following meanings:
-              --nn     Suppresses the normal change  of  directory  when  adding
-                     directories  to  the  stack,  so  that  only the stack is
+              --nn     Suppresses  the  normal  change  of directory when adding
+                     directories to the stack,  so  that  only  the  stack  is
                      manipulated.
-              ++_n     Rotates the stack so that  the  _nth  directory  (counting
-                     from  the  left  of the list shown by ddiirrss, starting with
+              ++_n     Rotates  the  stack  so  that the _nth directory (counting
+                     from the left of the list shown by  ddiirrss,  starting  with
                      zero) is at the top.
-              --_n     Rotates the stack so that  the  _nth  directory  (counting
-                     from  the  right of the list shown by ddiirrss, starting with
+              --_n     Rotates  the  stack  so  that the _nth directory (counting
+                     from the right of the list shown by ddiirrss,  starting  with
                      zero) is at the top.
               _d_i_r    Adds _d_i_r to the directory stack at the top, making it the
-                     new  current working directory as if it had been supplied
+                     new current working directory as if it had been  supplied
                      as the argument to the ccdd builtin.
 
               If the ppuusshhdd command is successful, a ddiirrss is performed as well.
-              If  the first form is used, ppuusshhdd returns 0 unless the cd to _d_i_r
-              fails.  With the second form, ppuusshhdd returns 0 unless the  direc-
-              tory  stack  is empty, a non-existent directory stack element is
-              specified, or the directory change to the specified new  current
+              If the first form is used, ppuusshhdd returns 0 unless the cd to  _d_i_r
+              fails.   With the second form, ppuusshhdd returns 0 unless the direc-
+              tory stack is empty, a non-existent directory stack  element  is
+              specified,  or the directory change to the specified new current
               directory fails.
 
        ppwwdd [--LLPP]
-              Print  the  absolute  pathname of the current working directory.
+              Print the absolute pathname of the  current  working  directory.
               The pathname printed contains no symbolic links if the --PP option
               is supplied or the --oo pphhyyssiiccaall option to the sseett builtin command
-              is enabled.  If the --LL option is used, the pathname printed  may
-              contain  symbolic links.  The return status is 0 unless an error
-              occurs while reading the name of the  current  directory  or  an
+              is  enabled.  If the --LL option is used, the pathname printed may
+              contain symbolic links.  The return status is 0 unless an  error
+              occurs  while  reading  the  name of the current directory or an
               invalid option is supplied.
 
        rreeaadd [--eerrss] [--aa _a_n_a_m_e] [--dd _d_e_l_i_m] [--ii _t_e_x_t] [--nn _n_c_h_a_r_s] [--NN _n_c_h_a_r_s] [--pp
        _p_r_o_m_p_t] [--tt _t_i_m_e_o_u_t] [--uu _f_d] [_n_a_m_e ...]
-              One  line  is  read  from  the  standard input, or from the file
-              descriptor _f_d supplied as an argument to the --uu option, and  the
+              One line is read from the  standard  input,  or  from  the  file
+              descriptor  _f_d supplied as an argument to the --uu option, and the
               first word is assigned to the first _n_a_m_e, the second word to the
-              second _n_a_m_e, and so on, with leftover words and their  interven-
-              ing  separators  assigned  to the last _n_a_m_e.  If there are fewer
+              second  _n_a_m_e, and so on, with leftover words and their interven-
+              ing separators assigned to the last _n_a_m_e.  If  there  are  fewer
               words read from the input stream than names, the remaining names
-              are  assigned  empty  values.  The characters in IIFFSS are used to
-              split the line into words using the same rules  the  shell  uses
+              are assigned empty values.  The characters in IIFFSS  are  used  to
+              split  the  line  into words using the same rules the shell uses
               for expansion (described above under WWoorrdd SSpplliittttiinngg).  The back-
-              slash character (\\) may be used to remove  any  special  meaning
+              slash  character  (\\)  may be used to remove any special meaning
               for the next character read and for line continuation.  Options,
               if supplied, have the following meanings:
               --aa _a_n_a_m_e
@@ -940,81 +942,86 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
                      new  values  are  assigned.   Other  _n_a_m_e  arguments  are
                      ignored.
               --dd _d_e_l_i_m
-                     The  first  character  of  _d_e_l_i_m is used to terminate the
+                     The first character of _d_e_l_i_m is  used  to  terminate  the
                      input line, rather than newline.
               --ee     If the standard input is coming from a terminal, rreeaaddlliinnee
-                     (see  RREEAADDLLIINNEE  above) is used to obtain the line.  Read-
-                     line uses the current (or default, if  line  editing  was
+                     (see RREEAADDLLIINNEE above) is used to obtain the  line.   Read-
+                     line  uses  the  current (or default, if line editing was
                      not previously active) editing settings.
               --ii _t_e_x_t
-                     If  rreeaaddlliinnee  is  being  used  to  read the line, _t_e_x_t is
+                     If rreeaaddlliinnee is being used  to  read  the  line,  _t_e_x_t  is
                      placed into the editing buffer before editing begins.
               --nn _n_c_h_a_r_s
-                     rreeaadd returns after reading _n_c_h_a_r_s characters rather  than
-                     waiting  for a complete line of input, but honor a delim-
-                     iter if fewer than _n_c_h_a_r_s characters are read before  the
+                     rreeaadd  returns after reading _n_c_h_a_r_s characters rather than
+                     waiting for a complete line of input, but honor a  delim-
+                     iter  if fewer than _n_c_h_a_r_s characters are read before the
                      delimiter.
               --NN _n_c_h_a_r_s
-                     rreeaadd  returns  after  reading  exactly  _n_c_h_a_r_s characters
-                     rather than waiting for a complete line of input,  unless
-                     EOF  is encountered or rreeaadd times out.  Delimiter charac-
-                     ters encountered in the input are not  treated  specially
-                     and  do  not cause rreeaadd to return until _n_c_h_a_r_s characters
+                     rreeaadd returns  after  reading  exactly  _n_c_h_a_r_s  characters
+                     rather  than waiting for a complete line of input, unless
+                     EOF is encountered or rreeaadd times out.  Delimiter  charac-
+                     ters  encountered  in the input are not treated specially
+                     and do not cause rreeaadd to return until  _n_c_h_a_r_s  characters
                      are read.
               --pp _p_r_o_m_p_t
                      Display _p_r_o_m_p_t on standard error, without a trailing new-
                      line, before attempting to read any input.  The prompt is
                      displayed only if input is coming from a terminal.
               --rr     Backslash does not act as an escape character.  The back-
-                     slash  is considered to be part of the line.  In particu-
-                     lar, a backslash-newline pair may not be used as  a  line
+                     slash is considered to be part of the line.  In  particu-
+                     lar,  a  backslash-newline pair may not be used as a line
                      continuation.
               --ss     Silent mode.  If input is coming from a terminal, charac-
                      ters are not echoed.
               --tt _t_i_m_e_o_u_t
-                     Cause rreeaadd to time out and return failure if  a  complete
-                     line  of  input  (or a specified number of characters) is
-                     not read within _t_i_m_e_o_u_t seconds.  _t_i_m_e_o_u_t may be a  deci-
-                     mal  number with a fractional portion following the deci-
-                     mal point.  This option is  only  effective  if  rreeaadd  is
-                     reading  input  from  a  terminal, pipe, or other special
-                     file; it has no effect when reading from  regular  files.
+                     Cause  rreeaadd  to time out and return failure if a complete
+                     line of input (or a specified number  of  characters)  is
+                     not  read within _t_i_m_e_o_u_t seconds.  _t_i_m_e_o_u_t may be a deci-
+                     mal number with a fractional portion following the  deci-
+                     mal  point.   This  option  is  only effective if rreeaadd is
+                     reading input from a terminal,  pipe,  or  other  special
+                     file;  it  has no effect when reading from regular files.
                      If rreeaadd times out, rreeaadd saves any partial input read into
-                     the specified variable  _n_a_m_e.   If  _t_i_m_e_o_u_t  is  0,  rreeaadd
-                     returns  immediately,  without  trying  to read any data.
-                     The exit status is 0 if input is available on the  speci-
-                     fied  file descriptor, non-zero otherwise.  The exit sta-
+                     the  specified  variable  _n_a_m_e.   If  _t_i_m_e_o_u_t  is 0, rreeaadd
+                     returns immediately, without trying  to  read  any  data.
+                     The  exit status is 0 if input is available on the speci-
+                     fied file descriptor, non-zero otherwise.  The exit  sta-
                      tus is greater than 128 if the timeout is exceeded.
               --uu _f_d  Read input from file descriptor _f_d.
 
               If no _n_a_m_e_s are supplied, the line read is assigned to the vari-
-              able  RREEPPLLYY.   The  return  code  is zero, unless end-of-file is
-              encountered, rreeaadd times out (in which case the  return  code  is
-              greater  than 128), a variable assignment error (such as assign-
-              ing to a readonly variable) occurs, or an invalid file  descrip-
+              able RREEPPLLYY.  The return code  is  zero,  unless  end-of-file  is
+              encountered,  rreeaadd  times  out (in which case the return code is
+              greater than 128), a variable assignment error (such as  assign-
+              ing  to a readonly variable) occurs, or an invalid file descrip-
               tor is supplied as the argument to --uu.
 
        rreeaaddoonnllyy [--aaAAff] [--pp] [_n_a_m_e[=_w_o_r_d] ...]
-              The  given  _n_a_m_e_s are marked readonly; the values of these _n_a_m_e_s
-              may not be changed by subsequent assignment.  If the  --ff  option
-              is  supplied,  the  functions  corresponding to the _n_a_m_e_s are so
-              marked.  The  --aa  option  restricts  the  variables  to  indexed
-              arrays;  the  --AA  option  restricts the variables to associative
-              arrays.  If both options are supplied, --AA takes precedence.   If
-              no  _n_a_m_e arguments are given, or if the --pp option is supplied, a
+              The given _n_a_m_e_s are marked readonly; the values of  these  _n_a_m_e_s
+              may  not  be changed by subsequent assignment.  If the --ff option
+              is supplied, the functions corresponding to  the  _n_a_m_e_s  are  so
+              marked.   The  --aa  option  restricts  the  variables  to indexed
+              arrays; the --AA option restricts  the  variables  to  associative
+              arrays.   If both options are supplied, --AA takes precedence.  If
+              no _n_a_m_e arguments are given, or if the --pp option is supplied,  a
               list of all readonly names is printed.  The other options may be
-              used  to  restrict the output to a subset of the set of readonly
-              names.  The --pp option causes output to be displayed in a  format
-              that  may be reused as input.  If a variable name is followed by
-              =_w_o_r_d, the value of the variable is set  to  _w_o_r_d.   The  return
-              status  is 0 unless an invalid option is encountered, one of the
+              used to restrict the output to a subset of the set  of  readonly
+              names.   The --pp option causes output to be displayed in a format
+              that may be reused as input.  If a variable name is followed  by
+              =_w_o_r_d,  the  value  of  the variable is set to _w_o_r_d.  The return
+              status is 0 unless an invalid option is encountered, one of  the
               _n_a_m_e_s is not a valid shell variable name, or --ff is supplied with
               a _n_a_m_e that is not a function.
 
        rreettuurrnn [_n]
-              Causes  a function to stop executing and return the value speci-
-              fied by _n to its caller.  If _n is omitted, the return status  is
-              that  of  the  last  command  executed in the function body.  If
+              Causes a function to stop executing and return the value  speci-
+              fied  by _n to its caller.  If _n is omitted, the return status is
+              that of the last command executed  in  the  function  body.   If
+              rreettuurrnn  is  executed by a trap handler, the last command used to
+              determine the status is the last  command  executed  before  the
+              trap  handler.   if  rreettuurrnn is executed during a DDEEBBUUGG trap, the
+              last command used to determine the status is  the  last  command
+              executed  by  the  trap  handler  before rreettuurrnn was invoked.  If
               rreettuurrnn is used outside a function, but  during  execution  of  a
               script  by  the ..  (ssoouurrccee) command, it causes the shell to stop
               executing that script and return either _n or the exit status  of
